/* C code */
#include <stdio.h>
#include <math.h>
#include "sched.h"

#define FAIL 0
#define SUCCEED 1
#define BEAM 5
#define B BEAM 




/* DATA */

int num_prereq[JOBS] = { 0,0,0,2,3,2,1,2,2,2,1,1,3,1,2,1,1,2,2 };
int job_time[JOBS] = { 4,2,2,13,20,11,21,44,32,25,43,51,
				13,16,13,33,22,11,44 };
int prereq[TOT] = { 0,1,0,1,2,1,2,2,3,4,5,6,5,7,8,1,
				5,6,3,12,13,9,14,10,14,11,8,11 };


/* STATE */
int obj_flag;
int 		finish_time[QUEUESIZE];
int 		wait_list[QUEUESIZE][JOBS];
int 		procr[QUEUESIZE][PROCS][2];
double 	f[QUEUESIZE];
int 		predecessor[QUEUESIZE];
int 		n_lnk[QUEUESIZE];

int num_of_jobs[QUEUESIZE];
int sum_of_times[QUEUESIZE];
	
/* FUNCTION USED BY 2LP to LINK 2LP CODE WITH C CODE */
void 	* GetExtDataAddr( char * );

/* FUNCTIONS CALLED BY insert_states */
void 	find_and_fill_slot(int j);
void 	splice(int j,int pre,int post);

/* FUNCTIONS CALLED BY 2LP CODE */
void		init_queue_vars();
int 		add_move( int ste, int top, int job );
int		start_empty_job( int ste, int i );
void		insert_states( int i, int top );
void		init_first_node();
void 	find_times_and_proc( );
int 		goal(int ste);
		
/* VARIABLES SHARED BY C CODE AND 2LP CODE */
int  	next_temps;
int 	temps;		/* temps  is the time that the first available processor
			   		 is ready for the next job */
int 	np;			/* Next processor to schedule */
int 	ste,top;

/* C FUNCTIONS */
int 	check_not_there( int top );
/*int	vertical_permus( int top );*/


void main(void)
{
char  name[128];

        fprintf(stderr,"Type in model name: /*  beam.2lp  */\n");
	fscanf(stdin,"%s",name);
        twolp(name);
        fprintf(stderr, "thank you for flying with us\n");
}



int add_move( int ste, int top, int job )
{
	int k;

	/* copy the finishing times from the last state 
	and put in new finishing time for processor np */
	memcpy(procr[top],procr[ste],sizeof(int)*PROCS*2);
	procr[top][np][0] = job;
	procr[top][np][1] = job_time[job] + temps;

	/* update latest finish_time */
	if( job_time[job] + temps > finish_time[ste] )
		finish_time[top] = job_time[job] + temps;
	else
		finish_time[top] = finish_time[ste];

	/* copy wait list and insert time that job finishes */
	memcpy(wait_list[top],wait_list[ste],sizeof(int)*JOBS);
	wait_list[top][job] = job_time[job] + temps;
	num_of_jobs[top] = num_of_jobs[ste] + 1;
	sum_of_times[top] = sum_of_times[ste] + job_time[job] + temps;
	/* only add states that are not already present */


		return SUCCEED;
	if( check_not_there( top ) )
	{
		/* update predecessor */
		predecessor[top] = ste;
		return SUCCEED;
	}
	return FAIL;
}

int check_not_there( int top )
{
int k;
int next_temps=999;
	int state, i,j;

	for( k=0;k<PROCS;k++) 
		/* Find the first available time */
		if( procr[ste][k][FIN_TIME] < next_temps)
		 {
			/* next_temps is the time that the first available
			 processor is ready for the next job */
			next_temps = procr[ste][k][FIN_TIME]; 
		}
 
	for( state = 0; state < top; state++ ) 
	{
		if (num_of_jobs[state] != num_of_jobs[top]) continue; 
		if (obj_flag && sum_of_times[state] != sum_of_times[top]) continue; 
		for( j = 0; j < JOBS; j++)
			if( ( wait_list[state][j] == 0
				 && wait_list[top][j] != 0 ) ||
        				(wait_list[top][j] == 0 
						&&  wait_list[state][j] != 0 ))
        				 break;
		if( j == JOBS )
		{ /* The same jobs are scheduled */    
			/* Check that the same jobs are currently
			   scheduled and finish at the same times. */
			for ( i=0;i<PROCS;i++ )
			{
				if (procr[top][i][FIN_TIME] == next_temps) continue;
				for (j=0;j<PROCS;j++)
				{
					if(procr[top][i][JOB_NUM] == procr[state][j][JOB_NUM]
						&&
						(procr[top][i][FIN_TIME] == procr[state][j][FIN_TIME]))
					break;
				}
				if (j==PROCS)
					break;
			}
			if (i != PROCS)  continue;
			for ( i=0;i<PROCS;i++ )
			{
				if (procr[state][i][FIN_TIME] == next_temps) continue;
				for (j=0;j<PROCS;j++)
				{
					if(procr[state][i][JOB_NUM] == procr[top][j][JOB_NUM]
						&&
						(procr[state][i][FIN_TIME] == procr[top][j][FIN_TIME]))
					break;
				}
				if (j==PROCS)
					break;
			}
			if (i== PROCS) return FAIL; 
		}
  	 }
	return SUCCEED;
}

int start_empty_job( int ste, int top )
{
int k,job;
	/* The empty job is scheduled from time 
	    temps to time next_temps. */
	memcpy(procr[top],procr[ste],sizeof(int)*PROCS*2);	
	for(k=0;k<PROCS;k++) 
		if (k == np && procr[top][k][FIN_TIME] == temps) {
			procr[top][k][JOB_NUM] = JOBS;
			procr[top][k][FIN_TIME] = next_temps;
		}

	for(k=0;k<PROCS;k++) 
		if (procr[top][k][FIN_TIME] == temps) {
			next_temps = temps;
		}
	num_of_jobs[top] = num_of_jobs[ste] ;
	sum_of_times[top] = sum_of_times[ste];
	/* Update wait time */
	memcpy(wait_list[top],wait_list[ste],sizeof(int)*JOBS);

return SUCCEED;

	if( !check_not_there( top ) )
		return FAIL;
	
	/* update predecessor */
	predecessor[top] = ste;
	finish_time[top] = finish_time[ste];

   	return SUCCEED;
}


void insert_states( int i,int top ) 
{
	int j;
	/* top - i is the number of states to be added to queue */
	for ( j=i;j<top;j++) {
		if(n_lnk[ste] == NIL) 
			 splice(j,ste,NIL);
		else find_and_fill_slot(j);
	}
}

void splice(int j,int pre,int post)
{
	n_lnk[pre] = j;
	n_lnk[j] = post;
}

void find_and_fill_slot(int j)
{
int ptr,pre_ptr;

	pre_ptr = ste;
	ptr = n_lnk[ste];		/* Never insert before ste */
	for (;n_lnk[pre_ptr] != NIL;){
		if (f[j] < f[ptr]) 					
			 break;		/* Insertion spot found */
		if (f[j] == f[ptr] && num_of_jobs[j] > num_of_jobs[ptr]) 					
			 break;		/* Insertion spot found */
		pre_ptr = ptr;		/* Move pre_ptr up to ptr */	
		ptr = n_lnk[ptr];	/* Move ptr up to its successor*/
	}
	splice(j,pre_ptr,ptr);		/* Insert the new state */
}


goal(int ste)
{
	int j;
	
	return (num_of_jobs[ste] == JOBS);

       /* Are all jobs scheduled? */
        for ( j=0;j<JOBS;j++)
                if (wait_list[ste][j] == 0)
			return FAIL;

	return SUCCEED; 
}


void find_times_and_proc()
{
int k;
	for( k=0;k<PROCS;k++) 
		/* Find the first available processor */
		if( procr[ste][k][FIN_TIME] < temps)
		 {
			/* temps is the time that the first available
			 processor is ready for the next job */
			temps = procr[ste][k][FIN_TIME]; 
			np = k;  /* np is the next processor scheduled */
		} 

	/* Now find the time the next available processor will be finished */
	next_temps = temps;
	for( k = 0; k < PROCS; k++ )
		if( procr[ste][k][FIN_TIME] > temps && next_temps == temps )
			next_temps = procr[ste][k][FIN_TIME];
		else
			if( procr[ste][k][FIN_TIME] < next_temps
					 && procr[ste][k][FIN_TIME] != temps )
				next_temps = procr[ste][k][FIN_TIME];
}

void init_first_node()
{
	int i,j;
	next_temps = temps = np = 0;
	
	for(i=0;i<JOBS;i++)
		wait_list[0][i] = 0;

	finish_time[0] = 0;
	/*job JOBS is the idle JOB*/
	for(i=0;i<PROCS;i++) {
		procr[0][i][0] = JOBS;
		procr[0][i][1] = 0; /* The finishing time is 0. */
	}
}

void init_queue_vars()
{
	ste = 0;		/* First state to examine is root node */
	top = 1;		/* First empty slot on queue */
	n_lnk[0] = NIL;		/* First element on queue has no ancestor */
}


/******************************************
*  This function is needed by 2LP in      *
*  order to find the address of the       *
*  external data and functions            *
******************************************/
void * GetExtDataAddr( char * nm )
{
static struct ext_data
{
        char * name;
        void * address;
}
   ext_data_array[] =
   {
	/* STATE */
      	{ "finish_time", &finish_time },
      	{ "wait_list", wait_list },
      	{ "procr", procr },
	{ "f", f },
      	{ "predecessor", predecessor },
	{ "n_lnk", n_lnk },

	/* DATA */
      	{ "prereq" , prereq },
      	{ "job_time", job_time },
	{ "num_prereq", num_prereq },

	/* VARIABLES */
      	{ "ste", &ste }, 
      	{ "temps", &temps },
      	{ "np", &np },
      	{ "next_temps", &next_temps },
	{ "top", &top },
	{ "obj_flag", &obj_flag },

	/* FUNCTIONS CALLED BY 2LP CODE */
	{ "add_move", add_move },
      	{ "start_empty_job", start_empty_job },
      	{ "insert_states", insert_states },
      	{ "init_first_node", init_first_node },
	{ "init_queue_vars", init_queue_vars },
	{ "goal", goal },
	{ "find_times_and_proc", find_times_and_proc },
	{ "", NULL } /*  To signal end of list */

   };

	int   i;

	for( i = 0; ; i++ )
	{
		if( !ext_data_array[ i ].name )
			continue;
		if( !ext_data_array[ i ].name[ 0 ] )
			break;
		if( !strcmp( ext_data_array[ i ].name, nm ) )
			return ( void * )ext_data_array[ i ].address;
   	}
   return NULL;
}
